﻿// PREFERENCES

// The game title
var title = "Demo";
var titleimage = "";

// The game width and height
var xsize = 800;
var ysize = 600;

// The textbox image, or ""
var advboximage = "";
var nvlboximage = "";
var msgboximage = "";
// Alternatively, the textbox color, given as a color name, rgba, or hex code
var boxcolor = "rgba(175, 222, 238, .6)";

// The button image, or ""
var bt_button_image = "";
var bt_button_image_hover = "";
// Alternatively, the button color
var bt_button_color = "rgba(175, 222, 238, .6)";
var bt_button_color_hover = "rgba(175, 255, 238, .7)";

// The text color
var textcolor = "#442e26";
// The font.
var font = "Consolas";
var fontsize = "18px";
// The amount of space between lines of text
var spacing = 10;

// The type of game, "adv" or "nvl" or "msg"
var type = "adv";
// The max number of lines that can be displayed on an nvl page
var lines = 5;

// STORY
function bt_story() {

// You can put variables here
var fun = 0;

// The first label in the story (it must exist with this name)
story = [
  bg, "resources/background.jpg",
  show, "right", "resources/chrono.png",
  function() { bt_dissolve(); },
  name, "Chrono",
  "Hello!",
  "This is the default mode.",
  newtype, "nvl",
  show, "none",
  wrap, "Thank you for viewing this demo.", "This is NVL style.",
  newtype, "msg",
  icon, "resources/chronoi.png", "This is MSG mode.",
  newtype, "adv",
  "This is the ADV style.",
  name, "",
  "Choice demo - what feature do you want to view?",
  function() { bt_menu(
    ["The insert function", examplelabel],
    ["A GUI changing function", examplelabel2],
    ["The menu function", ""]
  ); },
  "You just saw the menu function!",
  "The End",
  end
]
// Add other labels here. Please avoid using the prefix "bt_" for new labels as it may interfere with the game engine.
examplelabel = [
  function() { fun=1; },
  "Here's the insert function.",
  function() { bt_insert("It can show that your fun is "+fun+"."); },
  "The End",
  end
]
examplelabel2 = [
  function() { bt_advtext.size = "12px"; },
  "This text is small!",
  function() { bt_advtext.size = fontsize; },
  "The End",
  end
]

}

// COMMAND QUICKLIST
// bg, "<file name>",
// show, "right left or none", "<file name>",
// name, "<name>",
// wrap, "<first line of text>", "<second line of text>",
// clear,
// icon, "<file name>",
// newtype, "adv or nvl",
// end

// function() { bt_jump(<label>); },
// function() { bt_insert("<text>"); },
// function() { bt_menu(
//   ["<Choice>", <label>],
//   ["<Choice2>", <label2>]
// ); },


// MODIFICATIONS
function initialize() {
// You can put your own definitions and modifications here. Again, please avoid using the prefix "bt_"
}



// game engine mini version
function bt_text(a,b,c){this.type=c,this.size=fontsize,this.font=font,this.x=a,this.y=b,this.color=textcolor,this.name="","adv"==this.type?(this.text="",this.text2="",this.draw=function(){ctx=bt_room.context,ctx.font=this.size+" "+this.font,ctx.fillStyle=this.color,ctx.fillText(this.text,this.x,this.y+20+spacing),ctx.fillText(this.text2,this.x,this.y+40+2*spacing),ctx.font="bold "+fontsize+" "+this.font,ctx.fillText(this.name,this.x,this.y)}):"nvl"==this.type?(this.text=[],this.draw=function(){for(ctx=bt_room.context,ctx.font=this.size+" "+this.font,ctx.fillStyle=this.color,i=0;i<lines;i++)ctx.fillText(this.text[i],this.x,this.y+(20+spacing)*i)}):"msg"==this.type?(this.text=[],this.draw=function(){for(ctx=bt_room.context,ctx.font=this.size+" "+this.font,ctx.fillStyle=this.color,ctx.save(),this.text.length*(bt_icon_height+2*spacing)+20>ysize?ctx.translate(0,bt_max-this.text.length*(bt_icon_height+2*spacing)-20):bt_max=this.text.length*(bt_icon_height+2*spacing)+20,i=0;i<this.text.length;i++)""!=this.text[i][1]&&(bt_icon.src=this.text[i][1],ctx.drawImage(bt_icon,this.x,this.y+(bt_icon_height+2*spacing)*i)),ctx.fillText(this.text[i][0],this.x+bt_icon_width+spacing,this.y+(bt_icon_height+2*spacing)*i+20);ctx.restore()}):(this.text="",this.draw=function(){ctx=bt_room.context,ctx.font=this.size+" "+this.font,ctx.fillStyle=this.color,ctx.fillText(this.text,this.x,this.y)})}function bt_box(a,b,c,d,e){this.width=a,this.height=b,this.x=d,this.y=e,this.color=boxcolor,this.visible=!1,this.image=new Image,this.image.ready=!1,this.image.onload=function(){this.ready=!0},this.image.src=c,this.draw=function(){ctx=bt_room.context,""==c?(ctx.fillStyle=this.color,ctx.fillRect(this.x,this.y,this.width,this.height)):this.image.ready&&ctx.drawImage(this.image,this.x,this.y,this.width,this.height)},bt_boxes.push(this)}function bt_button(a,b,c,d,e){this.x=a,this.y=b,this.index=e,this.width=bt_button_width,this.height=bt_button_height,this.color=bt_button_color,this.color_hover=bt_button_color_hover,this.image=new Image,this.image.ready=!1,this.image.onload=function(){this.ready=!0},this.image.src=bt_button_image,this.image_hover=new Image,this.image_hover.ready=!1,this.image_hover.onload=function(){this.ready=!0},this.image_hover.src=bt_button_image_hover,this.text=c,this.font=font,this.label=d,this.hovered=!1,this.clicked=!1,this.draw=function(){ctx=bt_room.context,this.hovered?""==bt_button_image_hover?(ctx.fillStyle=this.color_hover,ctx.fillRect(this.x,this.y,this.width,this.height)):this.image_hover.ready&&ctx.drawImage(this.image_hover,this.x,this.y,this.width,this.height):""==bt_button_image?(ctx.fillStyle=this.color,ctx.fillRect(this.x,this.y,this.width,this.height)):this.image.ready&&ctx.drawImage(this.image,this.x,this.y,this.width,this.height),ctx.font=fontsize+" "+this.font,ctx.fillStyle=textcolor,ctx.textAlign="center",ctx.fillText(this.text,this.x+this.width/2,this.y+2*this.height/3),ctx.textAlign="left"},this.interact=function(){var a=bt_room.canvas.getBoundingClientRect(),b=a.left+this.x,c=a.left+this.x+this.width,d=a.top+this.y,e=a.top+this.y+this.height;e<bt_room.y||d>bt_room.y||c<bt_room.x||b>bt_room.x?this.hovered=!1:this.hovered=!0,e<bt_room.yy||d>bt_room.yy||c<bt_room.xx||b>bt_room.xx?this.clicked=!1:this.clicked=!0,bt_arrow==this.index&&(this.hovered=!0),bt_arrow=="c"+this.index&&(this.clicked=!0)},this.action=function(){bt_inmenu=!1,""!=this.label&&bt_jump(this.label)}}function bt_showbox(){"adv"==type?bt_advbox.visible?bt_advbox.visible=!1:bt_advbox.visible=!0:"nvl"==type?bt_nvlbox.visible?bt_nvlbox.visible=!1:bt_nvlbox.visible=!0:bt_msgbox.visible?bt_msgbox.visible=!1:bt_msgbox.visible=!0}function bt_snd(a){this.sound=document.createElement("audio"),this.sound.src=a,this.sound.setAttribute("preload","auto"),this.sound.setAttribute("controls","none"),this.sound.style.display="none",document.body.appendChild(this.sound),this.play=function(){this.sound.play()},this.stop=function(){this.sound.pause()}}function bt_posi(a,b){this.x=a,this.y=b,this.image=new Image,this.image.src="",this.draw=function(){""!=this.image.src&&(ctx=bt_room.context,ctx.drawImage(this.image,this.x,this.y))},bt_posi_list.push(this)}function bt_load(a,b,c){a.image.onload=c,a.image.src=b}function bt_jump(a){story.splice(bt_line,story.length-bt_line-1),a.forEach(function(a){story.push(a)})}function bt_menu(){for(bt_btns=[],i=0;i<arguments.length;++i)bt_btns.push(new bt_button((xsize-bt_button_width)/2,(ysize-bt_button_height)/3+i*(bt_button_height+spacing),arguments[i][0],arguments[i][1],i));bt_inmenu=!0}function bt_insert(){for(i=0;i<arguments.length;++i)story.splice(bt_line+1+i,0,arguments[i])}function bt_dissolve(){bt_opacity=0}function bt_checkcmd(){bt_cmd=!1,story[bt_line]>4&&(bt_cmd=!0)}function bt_runcmd(){if(story[bt_line]==music&&(bt_line++,"none"==story[bt_line]||""==story[bt_line]?bt_music.stop():(bt_music.sound.src=story[bt_line],bt_music.play())),story[bt_line]==show)if(bt_line++,"none"==story[bt_line])for(i=0;i<bt_posi_list.length;++i)bt_posi_list[i].image.src="";else bt_update=!1,"right"==story[bt_line]?bt_load(bt_rposi,story[bt_line+1],function(){bt_rposi.x=xsize-bt_rposi.image.width,bt_rposi.y=ysize-bt_rposi.image.height,bt_update=!0}):"left"==story[bt_line]?bt_load(bt_lposi,story[bt_line+1],function(){bt_lposi.y=ysize-bt_lposi.image.height,bt_update=!0}):"center"==story[bt_line]?bt_load(bt_cposi,story[bt_line+1],function(){bt_cposi.x=xsize/2-bt_cposi.image.width/2,bt_cposi.y=ysize-bt_cposi.image.height,bt_update=!0}):bt_load(story[bt_line],story[bt_line+1],function(){bt_update=!0}),bt_line++;story[bt_line]==name&&(bt_advtext.name=story[++bt_line]),story[bt_line]==bg&&(bt_line++,bt_update=!1,bt_load(bt_bg,story[bt_line],function(){bt_update=!0})),bt_line++,"function"!=typeof story[bt_line]?bt_checkcmd():bt_cmd=!1,bt_cmd?bt_runcmd():(bt_line-=1,bt_next())}function bt_typechange(){bt_line++,bt_advbox.visible=!1,bt_nvlbox.visible=!1,bt_msgbox.visible=!1,"adv"==story[bt_line]?(type="adv",bt_advbox.visible=!0):"nvl"==story[bt_line]?(type="nvl",bt_nvlbox.visible=!0):(type="msg",bt_msgbox.visible=!0),bt_next()}function bt_next(){if(bt_line++,"function"==typeof story[bt_line])story[bt_line](),0==bt_inmenu&&bt_next();else if(story[bt_line]==newtype)bt_typechange();else if(bt_advbox.visible)bt_checkcmd(),bt_cmd?bt_runcmd():story[bt_line]==end?bt_line-=1:story[bt_line]==wrap?(bt_advtext.text=story[++bt_line],bt_advtext.text2=story[++bt_line]):(bt_advtext.text=story[bt_line],bt_advtext.text2="");else if(bt_nvlbox.visible)if(bt_linecount++,bt_checkcmd(),bt_cmd)bt_linecount-=1,bt_runcmd();else if(story[bt_line]==end)bt_line-=1,bt_linecount-=1;else if(story[bt_line]==clear){for(bt_linecount=-1,bt_nvltext.text=[],i=0;i<lines;i++)bt_nvltext.text.push("");bt_next()}else if(bt_linecount==lines){for(bt_linecount=-1,bt_nvltext.text=[],i=0;i<lines;i++)bt_nvltext.text.push("");bt_line-=1,bt_next()}else story[bt_line]==wrap?(bt_nvltext.text[bt_linecount]=story[++bt_line],bt_nvltext.text[++bt_linecount]=story[++bt_line]):bt_nvltext.text[bt_linecount]=story[bt_line];else bt_msgbox.visible&&(bt_checkcmd(),bt_cmd?bt_runcmd():story[bt_line]==end?bt_line-=1:story[bt_line]==icon?(bt_line++,bt_msgtext.text.push([story[bt_line+1],story[bt_line]]),bt_line++):bt_msgtext.text.push([story[bt_line],""]))}function bt_run(){for(bt_bg=new bt_posi(0,0),bt_posi_list=[],bt_advbox=new bt_box(5*xsize/6,ysize/4,advboximage,1*xsize/12,2*ysize/3),bt_nvlbox=new bt_box(5*xsize/6,5*ysize/6,nvlboximage,1*xsize/12,1*ysize/12),bt_msgbox=new bt_box(5*xsize/6,5*ysize/6,msgboximage,1*xsize/12,1*ysize/12),bt_advtext=new bt_text(1*xsize/8,3*ysize/4,"adv"),bt_nvltext=new bt_text(1*xsize/8,1*ysize/6,"nvl"),bt_msgtext=new bt_text(1*xsize/8,bt_icon_height,"msg"),i=0;i<lines;i++)bt_nvltext.text.push("");bt_rposi=new bt_posi(0,0),bt_lposi=new bt_posi(0,0),bt_cposi=new bt_posi(0,0),bt_music=new bt_snd(""),"adv"==type?bt_advbox.visible=!0:"nvl"==type?bt_nvlbox.visible=!0:bt_msgbox.visible=!0,initialize(),bt_story(),""==titleimage?(bt_menu(["Start",""]),bt_room.start()):bt_load(bt_bg,titleimage,function(){bt_menu(["Start",""]),bt_room.start()})}function bt_draw(){if(bt_update){for(bt_opacity<=1?(ctx=bt_room.context,ctx.globalAlpha=bt_opacity,bt_opacity+=bt_speed):bt_room.clear(),bt_bg.draw(),i=0;i<bt_posi_list.length;++i)bt_posi_list[i].draw();if(bt_inmenu)for(i=0;i<bt_btns.length;++i)bt_btns[i].draw(),bt_btns[i].interact(),bt_btns[i].clicked&&(bt_room.xx=!1,bt_room.yy=!1,bt_room.x=!1,bt_room.y=!1,bt_arrow=-1,bt_btns[i].action(),bt_next());else bt_boxes.forEach(function(a){a.visible&&a.draw()}),bt_opacity>=1&&(bt_advbox.visible&&bt_advtext.draw(),bt_nvlbox.visible&&bt_nvltext.draw(),bt_msgbox.visible&&bt_msgtext.draw())}}var bt_inmenu=!1,bt_scale=Math.min(xsize,window.innerWidth-20)/xsize;document.getElementById("gameTitle").innerHTML=title;var bt_room={canvas:document.createElement("canvas"),x:!1,y:!1,xx:!1,yy:!1,start:function(){this.canvas.width=xsize*bt_scale,this.canvas.height=ysize*bt_scale,this.context=this.canvas.getContext("2d"),document.getElementById("gameDiv").parentNode.insertBefore(bt_room.canvas,document.getElementById("gameDiv")),this.interval=setInterval(bt_draw,20),window.addEventListener("keyup",function(a){72==a.keyCode?bt_showbox():32==a.keyCode||13==a.keyCode?bt_inmenu?bt_arrow="c"+bt_arrow:bt_opacity<1?bt_opacity=1:bt_next():38==a.keyCode?bt_inmenu&&("string"==typeof bt_arrow?bt_arrow=0:bt_arrow>0&&(bt_arrow-=1)):40==a.keyCode&&bt_inmenu&&("string"==typeof bt_arrow?bt_arrow=0:bt_arrow<bt_btns.length-1&&bt_arrow++)}),this.canvas.addEventListener("mousemove",function(a){bt_inmenu&&(bt_room.x=a.clientX/bt_scale,bt_room.y=a.clientY/bt_scale)}),this.canvas.addEventListener("mouseup",function(a){bt_inmenu?(bt_room.xx=a.clientX/bt_scale,bt_room.yy=a.clientY/bt_scale):bt_next()}),this.context.save(),this.context.scale(bt_scale,bt_scale)},clear:function(){this.context.clearRect(0,0,xsize,ysize)}},bt_advtext,bt_nvltext,bt_msgtext,bt_icon=new Image;bt_icon.src="";var bt_icon_width=80,bt_icon_height=80,bt_max,bt_boxes=[],bt_advbox,bt_nvlbox,bt_msgbox,bt_btns=[],bt_button_width=5*xsize/6,bt_button_height=40,bt_arrow=-1,bt_music,bt_posi_list=[],bt_update=!0,bt_rposi,bt_lposi,bt_cposi,bt_line=-1,bt_linecount=-1,wrap=1,clear=9,newtype=2,icon=3,end=4,music=5,show=6,name=7,bg=8,bt_cmd=!1,bt_opacity=1,bt_speed=.1;bt_run();