﻿//******* This contains the demo + the LONG VERSION of the game engine. Please only use this version if you want to modify the game engine.

// PREFERENCES

// The game title
var title = "Demo";
var titleimage = "";

// The game width and height
var xsize = 800;
var ysize = 600;

// The textbox image, or ""
var advboximage = "";
var nvlboximage = "";
var msgboximage = "";
// Alternatively, the textbox color, given as a color name, rgba, or hex code
var boxcolor = "rgba(175, 222, 238, .6)";

// The button image, or ""
var bt_button_image = "";
var bt_button_image_hover = "";
// Alternatively, the button color
var bt_button_color = "rgba(175, 222, 238, .6)";
var bt_button_color_hover = "rgba(175, 255, 238, .7)";

// The text color
var textcolor = "#442e26";
// The font.
var font = "Consolas";
var fontsize = "18px";
// The amount of space between lines of text
var spacing = 10;

// The type of game, "adv" or "nvl" or "msg"
var type = "adv";
// The max number of lines that can be displayed on an nvl page
var lines = 5;

// STORY
function bt_story() {

// You can put variables here
var fun = 0;
var c = "Chrono";

// The first label in the story (it must exist with this name)
story = [
  bg, "resources/background.jpg",
  show, "right", "resources/chrono.png",
  function() { bt_dissolve(); },
  name, c,
  "Hello!",
  "This is the default mode.",
  newtype, "nvl",
  show, "none",
  wrap, "Thank you for viewing this demo.", "This is NVL style.",
  newtype, "msg",
  icon, "resources/chronoi.png", "This is MSG mode.",
  newtype, "adv",
  "This is the ADV style.",
  name, "",
  "Choice demo - what feature do you want to view?",
  function() { bt_menu(
    ["The insert function", examplelabel],
    ["A GUI changing function", examplelabel2],
    ["The menu function", ""]
  ); },
  "You just saw the menu function!",
  "The End",
  end
]
// Add other labels here. Please avoid using the prefix "bt_" for new labels as it may interfere with the game engine.
examplelabel = [
  "Here's the insert function.",
  function() { bt_insert("It can show that your fun is "+fun+"."); },
  "The End",
  end
]
examplelabel2 = [
  function() { bt_advtext.size = "12px"; },
  "This text is small!",
  function() { bt_advtext.size = fontsize; },
  "The End",
  end
]

}

// COMMAND QUICKLIST
// bg, "<file name>",
// show, "right left or none", "<file name>",
// name, "<name>",
// wrap, "<first line of text>", "<second line of text>",
// clear,
// icon, "<file name>",
// newtype, "adv or nvl",
// end

// function() { bt_jump(<label>); },
// function() { bt_insert("<text>"); },
// function() { bt_menu(
//   ["<Choice>", <label>],
//   ["<Choice2>", <label2>]
// ); },


// MODIFICATIONS
function initialize() {
// You can put your own definitions and modifications here. Again, please avoid using the prefix "bt_"
}


//game engine
var bt_inmenu = false;
var bt_scale = Math.min(xsize,window.innerWidth-20)/xsize;

//title
document.getElementById("gameTitle").innerHTML = title;

//bt_room
var bt_room = {
  canvas: document.createElement("canvas"),
  x: false,
  y: false,
  xx: false,
  yy: false,
  start: function() {
    this.canvas.width = xsize*bt_scale;
    this.canvas.height = ysize*bt_scale;
    this.context = this.canvas.getContext("2d");
    document.getElementById("gameDiv").parentNode.insertBefore(bt_room.canvas,document.getElementById("gameDiv"));
    this.interval = setInterval(bt_draw, 20);
    window.addEventListener('keyup', function(e) {
      if (e.keyCode == 72) { bt_showbox(); }
      else if (e.keyCode == 32 || e.keyCode == 13) {
        if (bt_inmenu) { bt_arrow = "c"+bt_arrow; }
        else if (bt_opacity<1) { bt_opacity = 1; }
        else { bt_next(); }
      }
      else if (e.keyCode == 38) {
        if (bt_inmenu) {
          if (typeof(bt_arrow)=="string") { bt_arrow = 0; }
          else { if (bt_arrow>0) { bt_arrow = bt_arrow-1 } }
        }
      }
      else if (e.keyCode == 40) {
        if (bt_inmenu) {
          if (typeof(bt_arrow)=="string") { bt_arrow = 0; }
          else { if (bt_arrow<bt_btns.length-1) { bt_arrow++; } }
        }
      }
    })
    this.canvas.addEventListener('mousemove', function(e) {
      if (bt_inmenu) { bt_room.x = e.clientX/bt_scale; bt_room.y = e.clientY/bt_scale; }
    })
    this.canvas.addEventListener('mouseup', function(e) {
      if (bt_inmenu) { bt_room.xx = e.clientX/bt_scale; bt_room.yy = e.clientY/bt_scale; }
      else { bt_next(); } 
    })
    this.context.save();
    this.context.scale(bt_scale,bt_scale);
  },
  clear: function() {
    this.context.clearRect(0, 0, xsize, ysize);
  }
}

//text
var bt_advtext;
var bt_nvltext;
var bt_msgtext;
var bt_icon = new Image();
bt_icon.src = "";
var bt_icon_width = 80;
var bt_icon_height = 80;
var bt_max;
function bt_text(x, y, type) {
  this.type = type;
  this.size = fontsize;
  this.font = font;
  this.x = x;
  this.y = y;
  this.color = textcolor;
  this.name = "";
  if (this.type == "adv") {
    this.text = "";
    this.text2 = "";
    this.draw = function() {
      ctx = bt_room.context;
      ctx.font = this.size+" "+this.font;
      ctx.fillStyle = this.color;
      ctx.fillText(this.text, this.x, this.y+20+spacing);
      ctx.fillText(this.text2, this.x, this.y+40+spacing*2);
      ctx.font = "bold "+fontsize+" "+this.font;
      ctx.fillText(this.name, this.x, this.y);
    }
  }
  else if (this.type == "nvl") {
    this.text = [];
    this.draw = function() {
      ctx = bt_room.context;
      ctx.font = this.size+" "+this.font;
      ctx.fillStyle = this.color;
      for (i=0; i<lines; i++) {
        ctx.fillText(this.text[i], this.x, this.y+(20+spacing)*(i));
      }
    }
  }
  else if (this.type == "msg") {
    this.text = [];
    this.draw = function() {
      ctx = bt_room.context;
      ctx.font = this.size+" "+this.font;
      ctx.fillStyle = this.color;
      ctx.save();
      if ((this.text.length)*(bt_icon_height+spacing*2)+20 > ysize) {
        ctx.translate(0,bt_max-(this.text.length)*(bt_icon_height+spacing*2)-20)
      }
      else { bt_max = this.text.length*(bt_icon_height+spacing*2)+20 }
      for (i=0; i<this.text.length; i++) {
        if (this.text[i][1] != "") {
          bt_icon.src = this.text[i][1];
          ctx.drawImage(bt_icon, this.x, this.y+(bt_icon_height+2*spacing)*(i));
        }
        ctx.fillText(this.text[i][0], this.x+bt_icon_width+spacing, this.y+(bt_icon_height+spacing*2)*(i)+20);
      }
      ctx.restore();
    }
  }
  else {
    this.text = "";
    this.draw = function() {
      ctx = bt_room.context;
      ctx.font = this.size+" "+this.font;
      ctx.fillStyle = this.color;
      ctx.fillText(this.text, this.x, this.y);
    }
  }
}

//box
var bt_boxes = [];
var bt_advbox;
var bt_nvlbox;
var bt_msgbox;
function bt_box(width,height,img,x,y) {
  this.width = width;
  this.height = height;
  this.x = x;
  this.y = y;
  this.color = boxcolor;
  this.visible = false;
  this.image = new Image();
  this.image.ready = false;
  this.image.onload = function() { this.ready = true; }
  this.image.src = img;
  this.draw = function() {
    ctx = bt_room.context;
    if (img == "") {
      ctx.fillStyle = this.color;
      ctx.fillRect(this.x, this.y, this.width, this.height);
    }
    else if (this.image.ready) {
      ctx.drawImage(this.image, this.x, this.y, this.width, this.height);
    }
  }
  bt_boxes.push(this);
}

//button
var bt_btns = [];
var bt_button_width = xsize*5/6;
var bt_button_height = 40;
var bt_arrow = -1;
function bt_button(x,y,text,label,index) {
  this.x = x;
  this.y = y;
  this.index = index;
  this.width = bt_button_width;
  this.height = bt_button_height;
  this.color = bt_button_color;
  this.color_hover = bt_button_color_hover;
  this.image = new Image();
  this.image.ready = false;
  this.image.onload = function() { this.ready = true; }
  this.image.src = bt_button_image;
  this.image_hover = new Image();
  this.image_hover.ready = false;
  this.image_hover.onload = function() { this.ready = true; }
  this.image_hover.src = bt_button_image_hover;
  this.text = text;
  this.font = font;
  this.label = label;
  this.hovered = false;
  this.clicked = false;
  this.draw = function() {
    ctx = bt_room.context;
    if (this.hovered) {
      if (bt_button_image_hover == "") {
        ctx.fillStyle = this.color_hover;
        ctx.fillRect(this.x, this.y, this.width, this.height);
      }
      else if (this.image_hover.ready) {
        ctx.drawImage(this.image_hover,this.x,this.y,this.width,this.height);
      }
    }
    else {
      if (bt_button_image == "") {
        ctx.fillStyle = this.color;
        ctx.fillRect(this.x, this.y, this.width, this.height);
      }
      else if (this.image.ready) {
        ctx.drawImage(this.image, this.x, this.y, this.width, this.height);
      }
    }
    ctx.font = fontsize+" "+this.font;
    ctx.fillStyle = textcolor;
    ctx.textAlign = "center";
    ctx.fillText(this.text, this.x+this.width/2, this.y+this.height*2/3);
    ctx.textAlign = "left";
  }
  this.interact = function() {
    var mask = bt_room.canvas.getBoundingClientRect();
    var myl = mask.left+this.x;
    var myr = mask.left+this.x+this.width;
    var myt = mask.top+this.y;
    var myb = mask.top+this.y+this.height;
    if ((myb<bt_room.y) || (myt>bt_room.y) || (myr<bt_room.x) || (myl>bt_room.x)) { this.hovered = false; } else { this.hovered = true; }
    if ((myb<bt_room.yy) || (myt>bt_room.yy) || (myr<bt_room.xx) || (myl>bt_room.xx)) { this.clicked = false; } else { this.clicked = true; }
    if (bt_arrow == this.index) { this.hovered = true; }
    if (bt_arrow == "c"+this.index) { this.clicked = true; }
  }
  this.action = function() {
    bt_inmenu = false;
    if (this.label!="") {
      bt_jump(this.label);
    }
  }
}

//show/hide box
function bt_showbox() {
  if (type == "adv") {
    if (bt_advbox.visible) { bt_advbox.visible = false; }
    else { bt_advbox.visible = true; }
  }
  else if (type == "nvl") {
    if (bt_nvlbox.visible) { bt_nvlbox.visible = false; }
    else { bt_nvlbox.visible = true; }
  }
  else {
    if (bt_msgbox.visible) { bt_msgbox.visible = false; }
    else { bt_msgbox.visible = true; }
  }
}
    
//music
var bt_music;
function bt_snd(src) {
  this.sound = document.createElement("audio");
  this.sound.src = src;
  this.sound.setAttribute("preload","auto");
  this.sound.setAttribute("controls","none");
  this.sound.style.display = "none";
  document.body.appendChild(this.sound);
  this.play = function() { this.sound.play(); }
  this.stop = function() { this.sound.pause(); }
}

//positions
var bt_posi_list = [];
var bt_update=true;
var bt_rposi;
var bt_lposi;
var bt_cposi;
function bt_posi(x,y) {
  this.x = x;
  this.y = y;
  this.image = new Image();
  this.image.src = "";
  this.draw = function() {
    if (this.image.src != "") {
      ctx = bt_room.context;
      ctx.drawImage(this.image, this.x, this.y);
    }
  }
  bt_posi_list.push(this);
}
function bt_load(posi, src, callback) {
  posi.image.onload = callback;
  posi.image.src = src;
}

//story track
var bt_line = -1;
var bt_linecount = -1;

//bt function
function bt_jump(label) {
  story.splice(bt_line,story.length-bt_line-1);
  label.forEach(function(v) {story.push(v)});
}
function bt_menu() {
  bt_btns = [];
  for(i=0;i<arguments.length;++i) {
    bt_btns.push(new bt_button((xsize-bt_button_width)/2,(ysize-bt_button_height)/3+i*(bt_button_height+spacing),arguments[i][0],arguments[i][1],i))
  }
  bt_inmenu = true;
}
function bt_insert() {
  for(i=0;i<arguments.length;++i){
    story.splice(bt_line+1+i,0,arguments[i]);
  }
}
function bt_dissolve() {
  bt_opacity = 0;
}

var wrap = 1;
var clear = 9;
var newtype = 2;
var icon = 3;
var end = 4;
var music = 5;
var show = 6;
var name = 7;
var bg = 8;

//story loop
var bt_cmd = false;
function bt_checkcmd() {
  bt_cmd = false;
  if (story[bt_line] > 4) { bt_cmd = true; }
}
function bt_runcmd() {
  if (story[bt_line] == music) {
    bt_line++;
    if (story[bt_line] == "none" || story[bt_line] == "") { bt_music.stop() }
    else {
      bt_music.sound.src = story[bt_line];
      bt_music.play();
    }
  }
  if (story[bt_line] == show) {
    bt_line++;
    if (story[bt_line] == "none" ) {
      for(i=0;i<bt_posi_list.length;++i) { bt_posi_list[i].image.src="";}
    }
    else {
      bt_update = false;
      if (story[bt_line] == "right") {
        bt_load(bt_rposi, story[bt_line+1], function() {
        bt_rposi.x = xsize-bt_rposi.image.width;
        bt_rposi.y = ysize-bt_rposi.image.height;
        bt_update = true;
        });
      }
      else if (story[bt_line] == "left") {
        bt_load(bt_lposi, story[bt_line+1], function() {
        bt_lposi.y = ysize-bt_lposi.image.height;
        bt_update = true;
        });
      }
      else if (story[bt_line] == "center") {
        bt_load(bt_cposi, story[bt_line+1], function() {
        bt_cposi.x = xsize/2-bt_cposi.image.width/2;
        bt_cposi.y = ysize-bt_cposi.image.height;
        bt_update = true;
        });
      }
      else { bt_load((story[bt_line]), story[bt_line+1], function() {
        bt_update = true;
      }); }
      bt_line++;
    }
  }
  if (story[bt_line] == name) {
    bt_advtext.name = story[++bt_line];
  }
  if (story[bt_line] == bg) {
    bt_line++;
    bt_update = false;
    bt_load(bt_bg, story[bt_line], function() { bt_update=true });
  }
  bt_line++;
  if ((typeof story[bt_line]) != "function")
  {bt_checkcmd();} else {bt_cmd=false;}
  if (bt_cmd) { bt_runcmd(); } else { bt_line = bt_line-1; bt_next(); }
}

function bt_typechange() {
  bt_line++;
  bt_advbox.visible = false;
  bt_nvlbox.visible = false;
  bt_msgbox.visible = false;
  if (story[bt_line] == "adv") {
    type = "adv";
    bt_advbox.visible = true;
  }
  else if (story[bt_line] == "nvl") {
    type = "nvl";
    bt_nvlbox.visible = true;
  }
  else {
    type = "msg";
    bt_msgbox.visible = true;
  }
  bt_next();
}

function bt_next() {
  bt_line++;
  if ((typeof story[bt_line]) == "function") {
    story[bt_line]();
    if (bt_inmenu == false) { bt_next(); };
  }
  else {
    if (story[bt_line] == newtype) { bt_typechange(); }
    else if (bt_advbox.visible) {
      bt_checkcmd();
      if (bt_cmd) { bt_runcmd(); }
      else if (story[bt_line] == end) { bt_line = bt_line-1; }
      else if (story[bt_line] == wrap) {
        bt_advtext.text = story[++bt_line];
        bt_advtext.text2 = story[++bt_line];
      }
      else { bt_advtext.text = story[bt_line]; bt_advtext.text2 = ""; }
    }
    else if (bt_nvlbox.visible) {
      bt_linecount++;
      bt_checkcmd();
      if (bt_cmd) { bt_linecount = bt_linecount-1; bt_runcmd(); }
      else if (story[bt_line] == end) {
        bt_line = bt_line-1;
        bt_linecount = bt_linecount-1
      }
      else if (story[bt_line] == clear) {
        bt_linecount = -1;
        bt_nvltext.text = [];
        for (i=0; i<lines; i++) { bt_nvltext.text.push(""); };
        bt_next();
      }
      else if (bt_linecount == lines) {
        bt_linecount = -1;
        bt_nvltext.text = [];
        for (i=0; i<lines; i++) { bt_nvltext.text.push(""); };
        bt_line = bt_line-1;
        bt_next();
      }
      else if (story[bt_line] == wrap) {
        bt_nvltext.text[bt_linecount] = story[++bt_line];
        bt_nvltext.text[++bt_linecount] = story[++bt_line];
      }
      else { bt_nvltext.text[bt_linecount] = story[bt_line]; }
    }
    else if (bt_msgbox.visible) {
      bt_checkcmd();
      if (bt_cmd) { bt_runcmd(); }
      else if (story[bt_line] == end) { bt_line = bt_line-1; }
      else if (story[bt_line] == icon) {
        bt_line++;
        bt_msgtext.text.push([story[bt_line+1], story[bt_line]]);
        bt_line++;
      }
      else { bt_msgtext.text.push([story[bt_line], ""]); }
    }
  }
}

//run
function bt_run() {
  bt_bg = new bt_posi(0,0);
  bt_posi_list = [];
  bt_advbox = new bt_box(xsize*5/6, ysize/4, advboximage, xsize*1/12, ysize*2/3);
  bt_nvlbox = new bt_box(xsize*5/6, ysize*5/6, nvlboximage, xsize*1/12, ysize*1/12);
  bt_msgbox = new bt_box(xsize*5/6, ysize*5/6, msgboximage, xsize*1/12, ysize*1/12);
  bt_advtext = new bt_text(xsize*1/8, ysize*3/4, "adv");
  bt_nvltext = new bt_text(xsize*1/8, ysize*1/6, "nvl");
  bt_msgtext = new bt_text(xsize*1/8, bt_icon_height, "msg");
  for (i=0; i<lines; i++) { bt_nvltext.text.push(""); };
  bt_rposi = new bt_posi(0,0);
  bt_lposi = new bt_posi(0,0);
  bt_cposi = new bt_posi(0,0);
  bt_music = new bt_snd("");
  if (type == "adv") { bt_advbox.visible = true; }
  else if (type=="nvl") { bt_nvlbox.visible = true; }
  else { bt_msgbox.visible = true; }
  initialize();
  bt_story();
  if (titleimage=="") { bt_menu(["Start", ""]); bt_room.start(); }
  else {bt_load(bt_bg, titleimage, function() {
    bt_menu(["Start", ""]);
    bt_room.start();
  } );}
}

var bt_opacity = 1;
var bt_speed = .1;
//draw
function bt_draw() {
  if (bt_update) {
    if (bt_opacity<=1) {
      ctx=bt_room.context;
      ctx.globalAlpha = bt_opacity;
      bt_opacity=bt_opacity+bt_speed;
    }
    else {
      bt_room.clear();
    }
    bt_bg.draw();
    for(i=0;i<bt_posi_list.length;++i) { bt_posi_list[i].draw();}
    if (bt_inmenu) {
      for(i=0;i<bt_btns.length;++i) {
        bt_btns[i].draw();
        bt_btns[i].interact();
        if (bt_btns[i].clicked) {
          bt_room.xx = false;
          bt_room.yy = false;
          bt_room.x = false;
          bt_room.y = false;
          bt_arrow = -1;
          bt_btns[i].action();
          bt_next();
        }
      }
    }
    else {
      bt_boxes.forEach(function(v) { if (v.visible) {v.draw();} });
      if (bt_opacity >= 1) {
        if (bt_advbox.visible) { bt_advtext.draw(); }
        if (bt_nvlbox.visible) { bt_nvltext.draw(); }
        if (bt_msgbox.visible) { bt_msgtext.draw(); }
      }
    }
  }
}

bt_run();